<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO;

class crm00023000RelatorioController extends TeknisaCrud {
    protected $dataSourceName = 'contato_relatoriosegundoretorno';

    protected $parcnegocioporcaso_dataSourceName = 'crm_classoportuni_parceiroporcaso';
    protected $relatoriosemconc_dataSourceName = 'contato_relatoriosemconclusao';
    protected $relatoriosemretorno_dataSourceName = 'contato_relatoriosemretorno';
    protected $relatoriotop10_dataSourceName = 'pararelatione_relatoriotop10';
    protected $sistemaporcaso_dataSourceName = 'crm_classoportuni_sistemaporcaso';

    protected $parameterBagColumns = array('P_NRORG','P_CDOPERADOR');

    public function searchSemRetorno (DTO\Request\Filter $request, DTO\Response $response) {
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->relatoriosemretorno_dataSourceName;
        parent::find($request, $response);
        $this->dataSourceName = $previous_dataSourceName;
    }

    public function searchSemConc (DTO\Request\Filter $request, DTO\Response $response) {
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->relatoriosemconc_dataSourceName;
        parent::find($request, $response);
        $this->dataSourceName = $previous_dataSourceName;
    }

    public function searchTop10 (DTO\Request\Filter $request, DTO\Response $response) {
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->relatoriotop10_dataSourceName;
        parent::find($request, $response);
        $this->dataSourceName = $previous_dataSourceName;
    }

    public function searchParcnegocioPorCaso (DTO\Request\Filter $request, DTO\Response $response) {
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->parcnegocioporcaso_dataSourceName;
        parent::find($request, $response);
        $this->dataSourceName = $previous_dataSourceName;
    }

    public function searchSistemaPorCaso (DTO\Request\Filter $request, DTO\Response $response) {
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->sistemaporcaso_dataSourceName;
        parent::find($request, $response);
        $this->dataSourceName = $previous_dataSourceName;
    }
}