<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;

class crm20000ConclusaoCasoController extends TeknisaCrud
{
    protected $dataSourceName = 'crm_conclusaocontato';
    //protected $parameterBagColumns = array("P_NRORG", "P_CDOPERADOR");

    protected $entityManager;
    protected $connection;
    protected $newCode;

    public function __construct ($crudService, $parameterBag, $entityManager, $newCode)
    {
        $this->entityManager = $entityManager;
        $this->newCode = $newCode;
        $this->connection    = $entityManager->getConnection();

        parent::__construct($crudService, $parameterBag);
    }

    public function save(DTO\Request $request, DTO\Response $response)
    {
        foreach($request->getDataSet()->getRows() as $row)
        {
            if (!array_key_exists('DTULTATU', $row)) $row['DTULTATU'] = null;
            if (!array_key_exists('IDATIVO', $row)) $row['IDATIVO'] = 'S';

            if ($row['__is_new'] && (!isset($row['NRSEQCONCLUSAO'])))
            {
                $row['NRSEQCONCLUSAO'] = $this->newCode->getCodeByTableName("CRM_CONCLUSAO", $row["NRORG"]);
                date_default_timezone_set('America/Sao_Paulo');
                $row['DTINCLUSAO'] = date('d/m/y');

                $this->setConcluido($row["NRSEQCONTATO"], $row["NRORG"]);

                $response->addDataSet(new DataSet("DADOS", array("NRSEQCONCLUSAO" => $row["NRSEQCONCLUSAO"], "DTINCLUSAO" => $row["DTINCLUSAO"])));
            }
            else
            {
                date_default_timezone_set('America/Sao_Paulo');
                $row['DTULTATU'] = date('d/m/y');
                $response->addDataSet(new DataSet("DADOS", array("DTULTATU" => $row["DTULTATU"])));
            }
        }

        parent::save($request, $response);
    }

    public function setConcluido($nrseqcontato, $nrorg)
    {
        $select = "UPDATE CONTATO
                      SET NRSEQSITUACAO = 3
                    WHERE NRSEQCONTATO  = :NRSEQCONTATO
                      AND NRORG         = :NRORG";

        $params = array
        (
            "NRSEQCONTATO" => $nrseqcontato,
            "NRORG"        => $nrorg
        );

        try
        {
            $std = $this->entityManager->getConnection()->prepare($select);
            $std->execute($params);
        }
        catch(\Exception $e)
        {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        };
    }
}