<?php
namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class ger00045000ProspectFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection       = $entityManager->getConnection();
    }
    
    public function insertProspectEvolNextTask($paramsInsertProspectEvolNextTask){

        $insert = "INSERT INTO FILACONTATO (DSFILACONTATO,DTPLANFILACONTA,CDOPERREAL,NRSEQFILACONTA,NRORG,DTINCLUSAO,NRORGINCLUSAO,
                               CDOPERINCLUSAO,NRPARCNEGOCIO,IDORIGFILACONTA,IDATIVO,NRCONTATO, NRPRIORFILACONT,NRSEQCONTATO, NRSEQINTERLOCUTOR, DSEMAILTAREFA, DSTELEFONETAREFA, NRSEQCLASSIFICATAREFA, CRM_NRORGTRAB)
                    VALUES (:DSFILACONTATO,
                            :DTPLANFILACONTA,
                            :CDOPERREAL,
                            :NRSEQFILACONTA,
                            :NRORG,
                             SYSDATE,
                            :NRORGINCLUSAO,
                            :CDOPERINCLUSAO,
                            :NRPARCNEGOCIO,
                             'M',
                             'S',
                            :NRCONTATO,
                            :NRPRIORFILACONT,
                            :NRSEQCONTATO, 
                            :NRSEQINTERLOCUTOR, 
                            :DSEMAILTAREFA, 
                            :DSTELEFONETAREFA, 
                            :NRSEQCLASSIFICATAREFA, 
                            :CRM_NRORGTRAB)";
                 
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertProspectEvolNextTask);
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function verificaTarefas($paramsVerificaTarefas){
        $select = "SELECT 
                     FC.NRSEQFILACONTA, 
                     FC.CDOPERREAL
                   FROM 
                     FILACONTATO FC
                     LEFT JOIN PARCNEGOCIO PN
                       ON PN.NRPARCNEGOCIO = FC.NRPARCNEGOCIO
                         AND PN.NRORG = PN.NRORG
                   WHERE FC.NRPARCNEGOCIO = :NRPARCNEGOCIO
                     AND FC.NRORG = :NRORG 
                     AND FC.CRM_NRORGTRAB = :CRM_NRORGTRAB
                     AND FC.DTREALFILACONTA IS NULL
                     AND FC.IDATIVO = 'S' 
                     AND PN.IDATIVO = 'S'
                    ";
                      
        try{
            $std = $this->connection->prepare($select);
            $std->execute($paramsVerificaTarefas);
            $tarefas = $std->fetchAll();
            return $tarefas;
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function selectProspectContact($paramsSelectProspectContact){
        $select = "SELECT NRSEQCONTATO
                     FROM CONTATO
                    WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
                      AND NRORG = :NRORG
                      AND UPPER(DSREFECONT) LIKE '%REFERENTE AO LEAD%'";
                      
        try{
            $std = $this->connection->prepare($select);
            $std->execute($paramsSelectProspectContact);
            $nrseqcontato = $std->fetchAll();
            return $nrseqcontato;
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function requestForInsertNrseqcontatoForNewOpportunity($paramsUpdateOpportunity){
        
        $update = "UPDATE CRM_OPORTUNI 
                      SET NRSEQCONTATO = :NRSEQCONTATO,
                          NRCONTATO = :NRSEQCONTATO    
                    WHERE NRSEQOPORT = :NRSEQOPORT";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsUpdateOpportunity);
        }
        catch(\Exception $e){
            throw $e;
        }; 
    }
    
    public function requestForUpdatePartnerType($paramsUpdatePartnerType){
        $update = "UPDATE PARCNEGOCIO
                      SET CDTIPOPARCPRINCIPAL = 'CLIENTE'
                    WHERE NRPARCNEGOCIO = :P_NRPARCNEGOCIO";
                    
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsUpdatePartnerType);
        }
        catch(\Exception $e){
            throw $e;
        }; 
        
    }
    
    public function requestForInsertPartnershipOfTypeClient($paramsInsertPartnership){
        try {
            $insert = "INSERT INTO PARCERIA
                            (NRPARCERIA, NRPARCNEGOCIO, CDTIPOPARCEIRO, NRORG, IDATIVO, DTINCLUSAO,
                                NRORGINCLUSAO, CDOPERINCLUSAO)
                        VALUES(
                            :NRPARCERIA,
                            :NRPARCNEGOCIO,
                             'CLIENTE',
                            :NRORG,
                             'S',
                             SYSDATE,
                            :NRORGOPER,
                            :CDOPERADOR
                        )";
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertPartnership);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function requestForInsertClient($paramsInsertClient){
        try{
            $insert = "INSERT INTO CLIENTE 
                            (CDCLIENTE, NRPARCNEGOCIO, IDTPIJURCLIE, NRINSJURCLIE,
                             NMRAZSOCCLIE, NMFANTCLIE, CDSEGMER, NRINSESTCLIE,
                             NRFUNCCLIE, VRFATUCLIE, DSHOMEPACLI, CDMODODIVULG, CDATIVCLI,
                             NRORG, NRORGINCLUSAO, CDOPERINCLUSAO, DTINCLUSAO)
                        VALUES(
                            :CDCLIENTE,
                            :NRPARCNEGOCIO,
                            :IDTPIJURCLIE,
                            :NRINSJURCLIE,
                            :NMRAZSOCCLIE,
                            :NMFANTCLIE,
                            :CDSEGMER,
                            :NRINSESTCLIE,
                            :NRFUNCCLIE,
                            :VRFATUCLIE,
                            :DSHOMEPACLI,
                            :CDMODODIVULG,
                            :CDATIVCLI,
                            :NRORG,
                            :NRORGINCLUSAO,
                            :CDOPERINCLUSAO,
                             SYSDATE
                        )";
            
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertClient);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForDeactivateProspect($paramsUpdateProspect){
        
        $update = "UPDATE PROSPECT
                      SET IDATIVO = 'N'
                    WHERE CDPROSPECT = :CDPROSPECT";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsUpdateProspect);
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function requestForInsertClientAddress($paramsInsertClientAddress){
        $insert = "INSERT INTO ENDECLIE (CDCLIENTE, IDTPENDECLIE, CDPAIS, SGESTADO, CDMUNICIPIO, CDBAIRRO, DSENDECLIE, 
                      NMBAIRCLIE, DSCOMPENDCLI, NRCEPCLIE, NRTELECLIE, NRRAMALCLIE ,DSEMAILCLIE, NRENDERECOPARC, 
                      NRORG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO)
              VALUES (
                :CDCLIENTE,
                :IDTPENDECLIE,
                :CDPAIS,
                :SGESTADO,
                :CDMUNICIPIO,
                :CDBAIRRO,
                :DSENDECLIE,
                :NMBAIRCLIE,
                :DSCOMPENDCLI,
                :NRCEPCLIE,
                :NRTELECLIE,
                :NRRAMALCLIE,
                :DSEMAILCLIE,
                :NRENDERECOPARC, 
                :NRORG,
                SYSDATE,
                :NRORGINCLUSAO,
                :CDOPERINCLUSAO,
                'S'
              )";
        
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertClientAddress);
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function requestForSelectProspectAddress($paramsSelectProspectAddress){
        
        $select = "SELECT IDTPENDEPROS, CDPAIS, SGESTADO, CDMUNICIPIO, CDBAIRRO, DSENDEPROS,
                NMBAIRPROS, DSCOMPENDPRO, NRCEPPROS, NRTELEPROS, NRRAMALPROS, DSEMAILPROS, NRENDERECOPARC
                FROM ENDEPROSPECT
                    WHERE CDPROSPECT = :CDPROSPECT
                        AND NRORG = :NRORG
                        AND CDPAIS IS NOT NULL
                        AND SGESTADO IS NOT NULL
                        AND CDMUNICIPIO IS NOT NULL";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute($paramsSelectProspectAddress);
            return $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function verifyFilialOper($paramsVerifyFilial) {
        if(!empty($paramsVerifyFilial['CDOPERINCLUSAO'])) {
            $select = "SELECT CDFILIAL, NRORG FROM FILIOPER
                        WHERE CDOPERADOR = :CDOPERINCLUSAO
                        AND   NRORG = :NRORG";
            try{
                $std = $this->connection->prepare($select);
                $std->execute($paramsVerifyFilial);
                $filial = $std->fetchAll();
                
                return $filial;
            }
            catch(\Exception $e){
                throw $e;
            };
        } else {
            return array();
        }
        
    }
    
    public function getOperador($paramsSelectOperador){
        
        $select = "SELECT INITCAP(NMOPERADOR) NMOPERADOR FROM OPERADOR
                        WHERE CDOPERADOR = :CDOPERREAL
                            AND NRORG = :NRORG";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute($paramsSelectOperador);
            return $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function getParceiro($paramsSelectOperador){
        
        $select = "SELECT INITCAP(NMPRINCIPALPARC) NMPRINCIPALPARC FROM PARCNEGOCIO
                        WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
                            AND NRORG = :NRORG";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute($paramsSelectOperador);
            return $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForSetTaskEndDate($paramsSetTaskEndDate){
        
        $update = "UPDATE FILACONTATO 
                   SET DTREALFILACONTA = SYSDATE
                   WHERE NRSEQFILACONTA = :NRSEQFILACONTA";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsSetTaskEndDate);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForDeactivateProspectTask($taskUpdateParams){
        
        $update = "UPDATE FILACONTATO
                   SET IDATIVO = 'N'
                   WHERE NRSEQFILACONTA = :NRSEQFILACONTA";
                   
        try{
            
            $std = $this->connection->prepare($update);
            $std->execute($taskUpdateParams);
            
        }catch(\Exception $e){
            
            throw $e;
            
        }
        
    }
    
     public function getInterlocutorParc($nrrelacionaparc, $nrorg){
            
        $selectInterlocutorParc = "SELECT NRPARCNEGRELAC
                                        FROM RELACIONAPARC
                                        WHERE NRRELACIONAPARC = '$nrrelacionaparc'
                                        AND NRORG = '$nrorg' " ;
        
        
        try{
            $std = $this->connection->prepare($selectInterlocutorParc);
            $std->execute();
            $nrparcnegocio = $std->fetchAll();
            
        }catch(\Exception $e){
            
            throw $e;
            
        }
        if(isset($nrparcnegocio[0]))
            return $nrparcnegocio[0]['NRPARCNEGRELAC'];
        
    }
    
    public function getEnderecoparcInterlocutor($nrparcnegocioInterlocutor, $nrorg){
            
        $selectInterlocutorParc = "SELECT NRENDERECOPARC
                                        FROM ENDERECOPARC
                                        WHERE NRPARCNEGOCIO = '$nrparcnegocioInterlocutor'
                                        AND NRORG = '$nrorg' " ;

        
        try{
            $std = $this->connection->prepare($selectInterlocutorParc);
            $std->execute();
            $nrenderecoparcInterlocutor = $std->fetchAll();
            
        }catch(\Exception $e){
            
            throw $e;
            
        }
        if(isset($nrenderecoparcInterlocutor[0]))
            return $nrenderecoparcInterlocutor[0]['NRENDERECOPARC'];
        else
            return false;
        
    }
    
    public function replicaEnderecoparcInterlocutor($paramsUpdateEndeparc){
            
        $update = "UPDATE ENDERECOPARC SET CDTIPOENDERECO = :CDTIPOENDERECO,
                        DTULTATU = SYSDATE, NRORGULTATU = :NRORGULTATU, CDOPERULTATU = :CDOPERULTATU, CDPAIS = :CDPAIS, SGESTADO = :SGESTADO, CDMUNICIPIO = :CDMUNICIPIO, CDBAIRRO = :CDBAIRRO, NMBAIRROENDERECO = :NMBAIRROENDERECO,
                       DSENDERECO = :DSENDERECO,  NRCEPENDERECO = :NRCEPENDERECO
                    WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO AND NRENDERECOPARC = :NRENDERECOPARC AND NRORG = :NRORG";
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsUpdateEndeparc);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function insertEnderecoparc($paramsInsertEndeparc){

        $insert = "INSERT INTO ENDERECOPARC (IDATIVO, NRPARCNEGOCIO, NRORG, NRENDERECOPARC, CDTIPOENDERECO,
                        DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, CDPAIS, SGESTADO, CDMUNICIPIO, CDBAIRRO, NMBAIRROENDERECO, DSCOMPLEENDERECO,
                        NRCEPENDERECO, DSENDERECO, NRIMOVELENDERECO)
         VALUES (:IDATIVO,
                 :NRPARCNEGOCIO,
                 :NRORG,
                 :NRENDERECOPARC,
                 :CDTIPOENDERECO,
                  SYSDATE,
                 :NRORGINCLUSAO,
                 :CDOPERINCLUSAO,
                 :CDPAIS,
                 :SGESTADO,
                 :CDMUNICIPIO,
                 :CDBAIRRO,
                 :NMBAIRROENDERECO,
                 :DSENDERECO,
                 :NRCEPENDERECO,
                 :DSCOMPLEENDERECO,
                 :NRIMOVELENDERECO
                )";
                 
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertEndeparc);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function setIdQualificadoProspect($paramsSetQualification){
        
        $update = "UPDATE 
                     CRM_STATUSPARC
                   SET 
                     IDSTATUS = :IDQUALIFICADO    
                   WHERE 
                     NRPARCNEGOCIO = :NRPARCNEGOCIO
                     AND NRORG = :NRORG
                     AND CRM_NRORGTRAB = :CRM_NRORGTRAB";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsSetQualification);
        }
        catch(\Exception $e){
            throw $e;
        }; 
    }
    
    public function insertConcorrProspect($paramsInsertConcorrProspect){
        
        $insert = "INSERT INTO CRM_CONCORRPROSPECT
                        (NRCONCORRPROSPECT, CDPROSPECT, NRCONCORRENTE, NRORG, DTINIVIGENCIA, DTFIMVIGENCIA,
                            DTINCLUSAO, DTULTATU, NRORGINCLUSAO, NRORGULTATU, CDOPERINCLUSAO, CDOPERULTATU)
                    VALUES(
                        :NRCONCORRPROSPECT,
                        :CDPROSPECT,
                        :NRCONCORRENTE,
                        :NRORG,
                        :DTINIVIGENCIA,
                        :DTFIMVIGENCIA,
                         SYSDATE,
                         SYSDATE,
                        :NRORG,
                        :NRORG,
                        :CDOPERINCLUSAO,
                        :CDOPERINCLUSAO
                    )";
    
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertConcorrProspect);
        }
        catch(\Exception $e){
            throw $e;
        }; 
        
    }
    
    public function updateConcorrProspect($paramsSetConcorr){
        
        $update = "UPDATE CRM_CONCORRPROSPECT 
                      SET DTINIVIGENCIA = :DTINIVIGENCIA,
                          DTFIMVIGENCIA = :DTFIMVIGENCIA,
                          NRCONCORRENTE = :NRCONCORRENTE
                    WHERE NRCONCORRPROSPECT = :NRCONCORRPROSPECT
                        AND NRORG = :NRORG";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsSetConcorr);
        }
        catch(\Exception $e){
            throw $e;
        }; 
    }
    
    public function deleteConcorrProspect($paramsDeleteConcorr){
        
        $delete = "DELETE FROM CRM_CONCORRPROSPECT 
                    WHERE NRCONCORRPROSPECT = :NRCONCORRPROSPECT
                        AND NRORG = :NRORG";
        
        try{
            $std = $this->connection->prepare($delete);
            $std->execute($paramsDeleteConcorr);
        }
        catch(\Exception $e){
            throw $e;
        }; 
    }
    
    public function validaCNPJCliente($paramsSelectClient){
        $select = "SELECT 
                     CLIENTE.NMRAZSOCCLIE
                   FROM 
                     CLIENTE
                     JOIN CRM_STATUSPARC
                       ON CRM_STATUSPARC.NRPARCNEGOCIO = CLIENTE.NRPARCNEGOCIO
                         AND CRM_STATUSPARC.NRORG = CLIENTE.NRORG
                         AND CRM_STATUSPARC.CRM_NRORGTRAB = :CRM_NRORGTRAB
                         AND CRM_STATUSPARC.STATUSPARC = 'CLIENTE'
                   WHERE 
                     CLIENTE.NRINSJURCLIE = :CNPJ
                     AND CLIENTE.NRORG = :NRORG" ;
                      
        try{
            $std = $this->connection->prepare($select);
            $std->execute($paramsSelectClient);
            return $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function createPartnership($params){
        $queryInsertParceria = "INSERT INTO PARCERIA(NRPARCERIA, NRORG, NRPARCNEGOCIO, CDTIPOPARCEIRO, IDATIVO, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
        VALUES(:NRPARCERIA, :NRORG, :NRPARCNEGOCIO, :CDTIPOPARCEIRO, :IDATIVO, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO)";
                      
        try{
            $std = $this->connection->prepare($queryInsertParceria);
            $std->execute($params);
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function setParceiroNegocio($params){
        $insert = "INSERT INTO PARCNEGOCIO (NRPARCNEGOCIO, NRORG, NMPRINCIPALPARC, NMSECUNDARIPARC, NRINSCRICAOPARC, IDATIVO, DTINCLUSAO,
                         NRORGINCLUSAO, CDOPERINCLUSAO, CDTIPOPARCPRINCIPAL, CDTIPOINSCRICAO,IDPESSOAFISICA)
                 VALUES (:NRPARCNEGOCIO,
                         :NRORG,
                         :NMPRINCIPALPARC,
                         :NMSECUNDARIPARC,
                         :NRINSCRICAOPARC,
                         :IDATIVO,
                          SYSDATE,
                         :NRORGINCLUSAO,
                         :CDOPERINCLUSAO,
                         :CDTIPOPARCPRINCIPAL,
                         :CDTIPOINSCRICAO,
                         :IDPESSOAFISICA)";             
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($params);
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function newContato($params){
        $query = "INSERT INTO CONTATO (CDPROSPECT, CDCLIENTE, CDFORNECED, DSREFECONT, IDSTATUSCONT, IDTPCONTATO, CDOPERCONT, NRORG, NRPARCNEGOCIO, IDATIVO, CDFILIAL, NRCONTATO, NRSEQCONTATO, DTHRCONTATO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
            SELECT PROS.CDPROSPECT, CLIE.CDCLIENTE, FORN.CDFORNECED, :DSREFECONT, :IDSTATUSCONT, :IDTPCONTATO, :CDOPERCONT, :NRORG, :NRPARCNEGOCIO, 'S' AS IDATIVO, :CDFILIAL, :NRCONTATO, :NRSEQCONTATO, SYSDATE AS DTHRCONTATO, SYSDATE AS DTINCLUSAO, :NRORG AS NRORGINCLUSAO, :CDOPERCONT
            FROM PARCNEGOCIO PARC LEFT JOIN PROSPECT PROS
            ON PARC.NRPARCNEGOCIO = PROS.NRPARCNEGOCIO AND PARC.IDATIVO = PROS.IDATIVO AND PARC.NRORG = PROS.NRORG
            LEFT JOIN CLIENTE CLIE
            ON PARC.NRPARCNEGOCIO = CLIE.NRPARCNEGOCIO AND PARC.IDATIVO = CLIE.IDATIVO AND PARC.NRORG = CLIE.NRORG
            LEFT JOIN FORNECEDOR FORN
            ON PARC.NRPARCNEGOCIO = FORN.NRPARCNEGOCIO AND PARC.IDATIVO = FORN.IDATIVO AND PARC.NRORG = FORN.NRORG
            WHERE PARC.NRPARCNEGOCIO = :NRPARCNEGOCIO AND PARC.NRORG = :NRORG AND PARC.IDATIVO = 'S'";        
        try{
            $std = $this->connection->prepare($query);
            $std->execute($params);
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    function isParamOperDifEditEvolActive($params) {
        $sql = "SELECT OPERDIFEVOL
                FROM CRM_PARAMETRIZACAO
                WHERE NRORG = :NRORG
                  AND IDATIVO = 'S'
                  AND ROWNUM = 1";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    function operToEditIsTheSame($params) {
        $sql = "SELECT (CASE CDOPEREVOL
                    WHEN :CDOPERADOR THEN 'S'
                    ELSE 'N' END) SAMEOPERADOR
                FROM EVOLCONT
                WHERE NRSEQEVOLCONT = :NRSEQEVOLCONT
                  AND NRORG         = :NRORG
                  AND ROWNUM        = 1";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    public function insertNewContact($params) {
        try {
            $sql = "INSERT INTO CONTATO (CDFILIAL, NRCONTATO, DTHRCONTATO, NRSEQCONTATO, DSREFECONT, IDSTATUSCONT, IDTPCONTATO, CDOPERCONT, DTULTATUCOTA, NRORG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU, NRPARCNEGOCIO, IDATIVO, IDGERAFATURA, IDORIGEMTICKET, IDNOVOTICKET, NRPRIORIDADE, IDCANCELADO, IDARQUIVADO, NRPARCORIGEM) 
                    VALUES (:P_CDFILIAL, :P_NRCONTATO, SYSDATE, :P_NRSEQCONTATO, :P_DSREFECONT, :P_IDSTATUSCONT, :P_IDTPCONTATO, :P_CDOPERADOR, SYSDATE, :P_NRORG, SYSDATE, :P_NRORG, :P_CDOPERADOR, :P_NRORG, :P_CDOPERADOR, :P_NRPARCNEGOCIO, 'S', 'NAO', 'CRM', 'S', :P_NRPRIORIDADE, 'N', 'N', :P_NRPARCNEGOCIO)";
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        }catch(\Exception $e){
            throw $e;
        }
    }
    
    function verificaCliente($nrparcnegocio, $nrorg, $nrinscricaoparc) {
        try {
            $sqlNr = "SELECT 
                        *
                      FROM 
                        CLIENTE
                      WHERE 
                        NRPARCNEGOCIO = :NRPARCNEGOCIO
                        AND NRORG     = :NRORG";
            
            $params = array(
                "NRORG" => $nrorg,
                "NRPARCNEGOCIO" => $nrparcnegocio
            );
            
            $stdNr = $this->connection->prepare($sqlNr);
            $stdNr->execute($params);
            
            $clienteNrparcnegocio = $stdNr->fetchAll();
            
            $sqlIns = "SELECT 
                         *
                       FROM 
                         CLIENTE
                       WHERE 
                         NRINSJURCLIE = :NRINSCRICAOPARC
                         AND NRORG    = :NRORG";
            
            $params = array(
                "NRORG" => $nrorg,
                "NRINSCRICAOPARC" => $nrinscricaoparc
            );
            
            $stdInsc = $this->connection->prepare($sqlIns);
            $stdInsc->execute($params);
            
            $clienteInscricao = $stdInsc->fetchAll();
            
            return array($clienteNrparcnegocio, $clienteInscricao);
        }catch(\Exception $e){
            throw $e;
        }
    }
    
    function updateClientWithoutNrParcNegocio($inscParc, $nrorg) {
        try {
            $sqlNr = "SELECT
                        NRPARCNEGOCIO
                      FROM
                        PARCNEGOCIO
                      WHERE
                        NRORG = :NRORG
                        AND NRINSCRICAOPARC = :NRINSJURCLIE
                        AND CDTIPOPARCPRINCIPAL IN ('CLIENTE', 'PROSPECT', 'CANDIDATO')";
                        
            $params1 = array(
                "NRORG" => $nrorg,
                "NRINSJURCLIE" => $inscParc
            );
            
            $stdNr = $this->connection->prepare($sqlNr);
            $stdNr->execute($params1); 
            $nrparcnegocio = $stdNr->fetchAll();
            if(!empty($nrparcnegocio)) {
                $nrparcnegocio = $nrparcnegocio[0];
                
                $sqlUp = "UPDATE 
                            CLIENTE
                          SET 
                            NRPARCNEGOCIO   = :NRPARCNEGOCIO
                          WHERE 
                            NRINSJURCLIE = :NRINSCRICAO
                            AND NRORG = :NRORG";
                
                $params = array(
                    "NRORG" => $nrorg,
                    "NRPARCNEGOCIO" => $nrparcnegocio,
                    "NRINSCRICAO" => $inscParc
                );
                
                $stdUp = $this->connection->prepare($sqlUp);
                $stdUp->execute($params);
            }
            
        }catch(\Exception $e){
            throw $e;
        }
    }
    
    public function updateStatusClie($row){
        try{
            $insert =  "UPDATE 
                          CRM_STATUSPARC
                        SET 
                          STATUSPARC      = :CDTIPOPARCPRINCIPAL,
                          CDOPERRESP      = :CDOPERRESP,
                          DTULTATU        = SYSDATE,
                          CDOPERULTATU    = :CDOPERULTATU
                        WHERE 
                          NRPARCNEGOCIO = :NRPARCNEGOCIO
                          AND NRORG = :NRORG
                          AND CRM_NRORGTRAB = :CRM_NRORGTRAB";
            
            $params = array(
                "NRPARCNEGOCIO"        => $row["NRPARCNEGOCIO"],
                "NRORG"                => $row["NRORG"],
                "CDOPERULTATU"         => $row["CDOPERULTATU"],
                "CRM_NRORGTRAB"        => $row["CRM_NRORGTRAB"],
                "CDOPERRESP"           => $row["CDOPERADOR"],
                "CDTIPOPARCPRINCIPAL"  => "CLIENTE"
            );
            $std = $this->connection->prepare($insert);
            $std->execute($params);
        }
        catch(\Exception $e){
            throw $e;
        }
    }
    
    public function pesquisaParceiro($filtro){
        try{
            $paramsTipo = '';
            if(isset($filtro['CDTIPOPARCPRINCIPAL']) && !empty($filtro['CDTIPOPARCPRINCIPAL'])) {
                $paramsTipo .= "AND CRM_STATUSPARC.STATUSPARC IN ('".implode("', '", $filtro['CDTIPOPARCPRINCIPAL'])."')";
                unset($filtro['CDTIPOPARCPRINCIPAL']);
            }
            if(isset($filtro['CDOPERRESP']) && !empty($filtro['CDOPERRESP'])) {
                $paramsTipo .= "AND CRM_STATUSPARC.CDOPERRESP = '".$filtro['CDOPERRESP']."'";
                unset($filtro['CDOPERRESP']);
            }
            $query =  "SELECT 
                         PARCNEGOCIO.NRPARCNEGOCIO,
                         TIPOPARCEIRO.NMTIPOPARCEIRO AS CDTIPOPARCPRINCIPAL,
                         NRINSCRICAOPARC,
                         NMSECUNDARIPARC,
                         NMPRINCIPALPARC,
                         PARCNEGOCIO.NRORG,
                         CRM_STATUSPARC.CRM_NRORGTRAB,
                         CRM_STATUSPARC.IDATIVO,
                         CRM_STATUSPARC.NRPARCRESP,
                         CRM_STATUSPARC.CDOPERRESP
                       FROM 
                         PARCNEGOCIO
                         JOIN CRM_STATUSPARC
                           ON CRM_STATUSPARC.NRORG = PARCNEGOCIO.NRORG
                             AND CRM_STATUSPARC.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO
                             AND CRM_STATUSPARC.CRM_NRORGTRAB = :P_CRM_NRORGTRAB
                         LEFT JOIN TIPOPARCEIRO
                           ON TIPOPARCEIRO.CDTIPOPARCEIRO = CRM_STATUSPARC.STATUSPARC
                             AND ( TIPOPARCEIRO.NRORG = PARCNEGOCIO.NRORG OR TIPOPARCEIRO.NRORG = 0 )
                       WHERE 
                         CRM_STATUSPARC.IDATIVO = 'S'
                         AND PARCNEGOCIO.NRPARCNEGOCIO IN (SELECT 
                                                                NRPARCNEGOCIO
                                                              FROM 
                                                                CRM_STATUSPARC ST
                                                              WHERE 
                                                                (ST.STATUSPARC = 'CLIENTE'
                                                                 OR ST.STATUSPARC = 'INTERLOCUTOR'
                                                                 OR ST.STATUSPARC = 'OPERADOR'
                                                                 OR ST.STATUSPARC = 'PROSPECT'
                                                                 OR ST.STATUSPARC = 'CANDIDATO')
                                                                AND ST.NRORG = :NRORG
                                                                AND ST.CRM_NRORGTRAB = :P_CRM_NRORGTRAB )
                         AND ((:IDTPOPERADOR = 'R' AND PARCNEGOCIO.CDOPERRESPONSAVEL IN (SELECT CDOPERADOR
                                                                                         FROM CRM_OPERREVENDA
                                                                                         WHERE NRREVENDA = :NRREVENDA))
                               OR :IDTPOPERADOR <> 'R')".$paramsTipo;
            
            $std = $this->connection->prepare($query);
            $std->execute($filtro);
            return $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
}
?>