<?php
namespace Teknisa\CRM\Service;

use Teknisa\CRM\Controller\TeknisaCrud;


class crm00050000InterlocutorRevendaService extends TeknisaCrud
{
    protected $interlocutorRevendaFactory;
    protected $newCode;
    
    public function __construct ($interlocutorRevendaFactory, $newCode){
        
        $this->interlocutorRevendaFactory        = $interlocutorRevendaFactory;
        $this->newCode                           = $newCode;

    }
    
    public function callForInsertPartnerCommunication($row){
        
        $row["NRCOMUNICAPARC"] = $this->newCode->getCodeByTableName("COMUNICAPARC", $row["NRORG"]);
        
        if(!isset($row["CDOPERADOR"])){
            
            $row["CDOPERADOR"] = $row["CDOPERINCLUSAO"];
            
        }
        
        $paramsInsertPartnerCommunication = array(
            
            "NRCOMUNICAPARC"        => $row["NRCOMUNICAPARC"],
            "NRPARCNEGOCIO"         => $row["NRPARCNEGOCIO"],
            "CDFORMACOMU"           => $row["CDFORMACOMU"],
            "CDCOMUNICAPARC"        => $row["CDCOMUNICAPARC"],
            "NRORG"                 => $row["NRORG"],
            "IDATIVO"               => $row["IDATIVO"],
            "NRORGINCLUSAO"         => $row["NRORG"],
            "CDOPERINCLUSAO"        => $row["CDOPERADOR"]
            
        );
        
        $this->interlocutorRevendaFactory->requestForInsertPartnerCommunication($paramsInsertPartnerCommunication);
        
    }
    
    public function callForInsertPartnerRelation($row){
        
        $row["NRRELACIONAPARC"] = $this->newCode->getCodeByTableName("RELACPARCNEG", $row["NRORG"], 1, 10, true);
        
        $paramsInsertPartnerRelation = array(
            
            "NRRELACIONAPARC"       => $row["NRRELACIONAPARC"],
            "NRORG"                 => $row["NRORG"],
            "NRPARCNEGOCIO"         => $row["NRPARCNEGOCIOREV"],
            "NRPARCNEGRELAC"        => $row["NRPARCNEGOCIO"],
            "IDATIVO"               => $row["IDATIVORELAC"],
            "NRORGINCLUSAO"         => $row["NRORG"],
            "CDOPERINCLUSAO"        => $row['CDOPERADOR']
            
        );
        
        $this->interlocutorRevendaFactory->requestForInsertPartnerRelation($paramsInsertPartnerRelation);
        
    }
    
    public function callForInsertPartnerParceria($row){
        
        $row["NRPARCERIA"] = $this->newCode->getCodeByTableName("PARCERIA", $row["NRORG"], 1, 6, true);
        
        $paramsInsertPartnerRelation = array(
            
            "NRPARCERIA"            => $row["NRPARCERIA"],
            "NRORG"                 => $row["NRORG"],
            "NRPARCNEGOCIO"         => $row["NRPARCNEGOCIO"],
            "CDTIPOPARCEIRO"        => 'INTERLOCUTOR',
            "IDATIVO"               => 'S',
            "NRORGINCLUSAO"         => $row["NRORG"],
            "CDOPERINCLUSAO"        => $row["CDOPERADOR"]
            
        );
        
        $this->interlocutorRevendaFactory->requestForInsertPartnerParceria($paramsInsertPartnerRelation);
        
    }
    
    public function callForDeletePartnerCommunication($row){
        
        $paramsDeletePartnerCommunication = array(
            
            "NRPARCNEGOCIO"         => $row["NRPARCNEGOCIO"]
            
        );
        
        $this->interlocutorRevendaFactory->requestForDeletePartnerCommunication($paramsDeletePartnerCommunication);
        
    }
    
    public function callForUpdateRelationState($row){
        
        $paramsUpdateRelationState = array(
            
            "NRPARCNEGOCIO"         => $row["NRPARCNEGOCIOREV"],
            "NRPARCNEGRELAC"        => $row["NRPARCNEGOCIO"],
            "IDATIVO"               => $row["IDATIVORELAC"]
            
        );

        $this->interlocutorRevendaFactory->requestForUpdateRelationState($paramsUpdateRelationState);
        
    }
    
    public function callForInactivatePartner($row){
        
        $paramsInactivatePartner = array(
            
            "NRPARCNEGOCIO"         => $row["NRPARCNEGOCIO"]
            
        );
        
        $this->interlocutorRevendaFactory->requestForInactivatePartner($paramsInactivatePartner);
        
    }
    
    public function callForDeleteResaleRelation($row){
        
        $paramsDeleteResaleRelation = array(
            
            "NRPARCNEGOCIO"         => $row["NRPARCNEGOCIOREV"],
            "NRPARCNEGRELAC"        => $row["NRPARCNEGOCIO"]
            
        );

        $this->interlocutorRevendaFactory->requestForDeleteResaleRelation($paramsDeleteResaleRelation);
        
    }
    
}
?>