/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CCTB                                                     */
/* Tabela : CONTCTBL                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CCTB'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CCTB
GO

CREATE TRIGGER DTULTATU_CCTB
ON CONTCTBL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CONTCTBL', null, 'CDNVCONTCTBL='+ CDNVCONTCTBL+ ';'+
                                       'CDCONTCTBL='  + CDCONTCTBL  + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CONTCTBL
      SET DTULTATUCCTB = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(CONTCTBL.CDCONTCTBL,0)   = ISNULL(INSERTED.CDCONTCTBL,0))   AND
            (ISNULL(CONTCTBL.NMCONTCTBL,0)   = ISNULL(INSERTED.NMCONTCTBL,0))   AND
            (ISNULL(CONTCTBL.CDNVCONTCTBL,0) = ISNULL(INSERTED.CDNVCONTCTBL,0)) AND
            (ISNULL(CONTCTBL.IDTIPOCONT,0)   = ISNULL(INSERTED.IDTIPOCONT,0))   AND
            (ISNULL(CONTCTBL.CDRATEIO,0)     = ISNULL(INSERTED.CDRATEIO,0))     AND
            (ISNULL(CONTCTBL.CDCONTREDU,0)   = ISNULL(INSERTED.CDCONTREDU,0))   AND
            (ISNULL(CONTCTBL.CDCONTANTE,0)   = ISNULL(INSERTED.CDCONTANTE,0))   AND
            (ISNULL(CONTCTBL.IDTIPOPESS,0)   = ISNULL(INSERTED.IDTIPOPESS,0))   AND
            (ISNULL(CONTCTBL.IDCONTCCUS,0)   = ISNULL(INSERTED.IDCONTCCUS,0))   AND
            (ISNULL(CONTCTBL.IDTIPOCOME,0)   = ISNULL(INSERTED.IDTIPOCOME,0));
   END;
END;
GO

